
#ifndef _CIRKSETTINGSFORM_H_
#define _CIRKSETTINGSFORM_H_

#include "cirksettingsformbase.h"

class CGIRK;
class QListViewItem;

/**
 * 
 * Craig Graham
 **/
class CIRKSettingsForm : public CIRKSettingsFormBase
{
  Q_OBJECT

public:
	CIRKSettingsForm(CGIRK *parent=0, const char *name=0, bool modal=false);
	~CIRKSettingsForm();
	void close();

protected:
	virtual void keyPressEvent(QKeyEvent *e);
	
public slots:
	void selectShiftKey();
	void selectPunctKey();
	void selectCmdKey();
	void selectNumKey();
	void selectFastKey();
	
	void changedKeyboard(int n);
	void changedShiftListSelection(QListViewItem *i);
	void changedNumListSelection(QListViewItem *i);
	void changedCmdListSelection(QListViewItem *i);
	void changedPunctListSelection(QListViewItem *i);
	void changedFastListSelection(QListViewItem *i);
	void changedShiftText(const QString&);
	void changedNumText(const QString&);
	void changedCmdText(const QString&);
	void changedPunctText(const QString&);
	void changedFastText(const QString&);
	void newShift();
	void newCmd();
	void newNum();
	void newPunct();
	void newFast();
	void deleteShift();
	void deleteCmd();
	void deleteNum();
	void deletePunct();
	void deleteFast();

	void enableDisableRepeat(bool enable);
	
private:
	void getKey(QLineEdit *pTarget,QPushButton *pTrigger);
	CGIRK *m_pIRK;
	QListViewItem *m_pCurrentShiftListItem;
	QListViewItem *m_pCurrentNumListItem;
	QListViewItem *m_pCurrentCmdListItem;
	QListViewItem *m_pCurrentPunctListItem;
	QListViewItem *m_pCurrentFastListItem;
	
	QLineEdit *m_pKeyTarget;
	QPushButton *m_pKeyTrigger;
};

#endif
