#include "MenuTitle.h"

MenuTitle::MenuTitle(const QString& s, const QFont& f)
{
	font = f;
	caption = s;
}

bool MenuTitle::fullSpan() const
{
	return(true);
}

bool MenuTitle::isSeparator() const
{
	return(true);
}

void MenuTitle::paint(QPainter* p, const QColorGroup& cg, bool /*act*/,
		bool /*enabled*/, int x, int y, int w, int h)
{
	QString name;
	QColor color;

	p->setFont(font);

	/* set fontcolor */
	p->setPen(black);

	/* set bgcolor */
	color = cg.mid();

	p->fillRect(x, y, w, h, QBrush(color));
	p->drawText(x, y, w, h, AlignCenter, caption);
}

QSize MenuTitle::sizeHint()
{
	return(QFontMetrics(font).size(AlignCenter, caption));
}
