#ifndef _TASK_SELECTOR_H_
#define _TASK_SELECTOR_H_

#include <qstring.h>
#include <qstringlist.h>
#include <qvaluelist.h>
#include <qwindowsystem_qws.h>
#include <qpopupmenu.h>
#include <qpoint.h>
#include <qtimer.h>
#include <qgfx_qws.h>

#include <qpe/global.h>
#include <qpe/applnk.h>
#include <qpe/config.h>
#include <qpe/mimetype.h>

#include "MenuTitle.h"
#include "AppLnkManager.h"
#include "QPopupMenuEx.h"

class TaskSelector : public QObject
{
	Q_OBJECT
public:
	TaskSelector(QWidget *pParent);
	~TaskSelector();

	bool startSelector();
	bool endSelector();
public slots:
	void show();
	void select();
	void select(int);
	void highlight(int id);
private:
	bool m_isShowing;
	int m_index;
	QPopupMenu* m_pMenu;
	QStringList m_applist;

	int buildMenu();
	void next();
private slots:
	bool eventFilter(QObject* o, QEvent* e);
};

#endif /* _TASK_SELECTOR_H_ */
