#include "TaskSwitcher.h"

TaskSwitcher::TaskSwitcher()
{
	qDebug("TaskSwitcher::TaskSwitcher()");
	m_pTimer=new QTimer(this);
	connect( m_pTimer, SIGNAL(timeout()), SLOT(clearList()) );
}

TaskSwitcher::~TaskSwitcher()
{
	qDebug("TaskSwitcher::~TaskSwitcher()");
}

void TaskSwitcher::doTaskSwitch(bool includeLauncher)
{
	if(m_applist.isEmpty()){
		/* get list */
		const QList<QWSWindow>& list = qwsServer->clientWindows();
		QWSWindow* w;
		for(QListIterator<QWSWindow> it(list); (w=it.current()); ++it){
			if(w->isVisible()){
				QString app = w->client()->identity();
				qDebug("applist[%s]", app.latin1());
				if(app != NULL && m_applist.contains(app) == false){
					m_applist.append(app);
				}
			}
		}
		m_appit = m_applist.begin();
	}
	if(m_applist.count() > 1){
		/* switch next */
		next();
		if((!includeLauncher)&&(*m_appit == "launcher")){
			next();
		}
		Global::execute(*m_appit);
	} else if((m_applist.count() == 1) && (!includeLauncher) && (*m_appit != "launcher")){
		Global::execute(*m_appit);
	} else {
		qDebug("no applications");
	}
	// start a timer so that the list will clear itself after 5 seconds
	m_pTimer->start(5000,true);
}

void TaskSwitcher:: clearList()
{
	m_applist.clear();
}


void TaskSwitcher::next()
{
	++m_appit;
	if(m_appit == m_applist.end()){
		m_appit = m_applist.begin();
	}	
}
