#include "irkimpl.h"
#include <qpixmap.h>
#include <stdio.h>
#include <lirc_client.h>
#include <stdlib.h>
#include <unistd.h>
#include "irk_build.h"
#include "Infrared.xpm"
#include "pocketop.xpm"
#include "targus.xpm"

QPixmap *IRKImpl::icn=NULL;
QPixmap *IRKImpl::icn_pocketop=NULL;
QPixmap *IRKImpl::icn_targus=NULL;


IRKImpl::IRKImpl()
    : input(0),ref(0)
{
	if ( !icn )
		icn = new QPixmap((const char **)Infrared_xpm);
	if(!icn_pocketop)
		icn_pocketop = new QPixmap((const char **)pocketop_xpm);
	if(!icn_targus)
		icn_targus = new QPixmap((const char **)targus_xpm);
}

IRKImpl::~IRKImpl()
{
    delete input;
}

QRESULT IRKImpl::queryInterface( const QUuid &uuid, QUnknownInterface **iface )
{
    *iface = 0;
    if ( uuid == IID_QUnknown )
        *iface = this;
    else if ( uuid == IID_InputMethod )
        *iface = this;

    if ( *iface )
        (*iface)->addRef();
    return QS_OK;
}

void IRKImpl::resetState()
{
}


QWidget *IRKImpl::inputMethod( QWidget *parent, Qt::WFlags f )
{
    if ( !input )
        input = new CGIRK( parent, "cgIRK", f );
    return input;
}


QString IRKImpl::name()
{
#if POCKETOP_BUILD
	if((input)&&(input->currentKeyboard()->mode()==IRKMODE_POCKETOP))
		return QString("Pocketop");
	else
#endif
	if((input)&&(input->currentKeyboard()->mode()==IRKMODE_TARGUS)) {
		return QString("Targus");
	} else {
		return QString("IRK");
	}
}


QPixmap *IRKImpl::icon()
{
	if((input)&&(input->currentKeyboard()->mode()==IRKMODE_POCKETOP))
		return icn_pocketop;
	else if((input)&&(input->currentKeyboard()->mode()==IRKMODE_TARGUS))
		return icn_targus;
	else
		return icn;
}


/*
 The onKeyPress() function must connect the supplied slot to the signal that is emitted when
 a key press is generated. 
 The following code will connect the signal to the supplied slot: 
*/

void IRKImpl::onKeyPress( QObject *receiver, const char *slot )
{
    if ( input )
        QObject::connect( input, SIGNAL(key(ushort,ushort,ushort,bool,bool)), receiver, slot );
}


Q_EXPORT_INTERFACE()
{
    Q_CREATE_INSTANCE( IRKImpl )
}

